Subject: Re: bug#60758: 29.0.60; while-let uses if-let* convention in contradiction to the docstring

From: Daniel Mendler <[email-masked]>
Date: Sat, 14 Jan 2023 17:29:19 +0100

On 1/14/23 17:11, Michael Heerdegen wrote:
> Daniel Mendler <[email-masked]> writes:
> 
>> But then it may make sense to deprecate `if-let` and `when-let`
>> altogether in favor of `if-let*` and `when-let*`?
> 
> I don't recall why that hasn't been done.  There was a very long
> discussion about it.  Probably the answer was "the syntax had been there
> for too long and now too many packages use it and we don't want to break
> them", I don't recall.  Maybe you can find these discussions.  There had
> not been an agreement at least.

Okay, I see. Would it be possible to deprecate the single-binding syntax
via `macroexp-warn-and-return'? Or do you plan to introduce byte
compiler warnings? Given that `while-let' has been introduced without
support for single bindings it may be better then to deprecate the
starred variants in the long term, such that we end up only with
`if-let', `when-let', `while-let' etc.?

Daniel